LeetCode //C - 127. Word Ladder

127. Word Ladder

A transformation sequence from word beginWord to word endWord using a dictionary wordList is a sequence of words beginWord -> s1 -> s2 -> ... -> sk such that:

  • Every adjacent pair of words differs by a single letter.
  • Every si for 1 <= i <= k is in wordList. Note that beginWord does not need to be in wordList.
  • sk == endWord

Given two words, beginWord and endWord, and a dictionary wordList, return the number of words in the shortest transformation sequence from beginWord to endWord, or 0 if no such sequence exists.

Example 1:

Input: beginWord = "hit", endWord = "cog", wordList = "hot","dot","dog","lot","log","cog"
Output: 5
Explanation: One shortest transformation sequence is "hit" -> "hot" -> "dot" -> "dog" -> cog", which is 5 words long.

Example 2:

Input: beginWord = "hit", endWord = "cog", wordList = "hot","dot","dog","lot","log"
Output: 0
Explanation: The endWord "cog" is not in wordList, therefore there is no valid transformation sequence.

Constraints:
  • 1 <= beginWord.length <= 10
  • endWord.length == beginWord.length
  • 1 <= wordList.length <= 5000
  • wordListi.length == beginWord.length
  • beginWord, endWord, and wordListi consist of lowercase English letters.
  • beginWord != endWord
  • All the words in wordList are unique.

From: LeetCode

Link: 127. Word Ladder


Solution:

Ideas:
  1. Start with beginWord "hit" and level 1.
  • Queue = "hit"
  1. Dequeue "hit" and explore its neighbors:
  • Check each word in wordList to find neighbors of "hit" (words that are one letter different and unvisited).
  • "hot" is a neighbor. Mark "hot" as visited and enqueue it.
  • Queue = "hot"
  • Increase level to 2.
  1. Dequeue "hot" and explore its neighbors:
  • Find neighbors of "hot" (unvisited words in wordList that are one letter different).
  • "dot" and "lot" are neighbors. Mark them as visited and enqueue them.
  • Queue = "dot", "lot"
  • Increase level to 3.
  1. Dequeue "dot" and explore its neighbors:
  • Find neighbors of "dot".
  • "dog" is a neighbor. Mark "dog" as visited and enqueue it.
  • Queue = "lot", "dog"
  1. Dequeue "lot" and explore its neighbors:
  • Find neighbors of "lot".
  • "log" is a neighbor. Mark "log" as visited and enqueue it.
  • Queue = "dog", "log"
  • Increase level to 4.
  1. Dequeue "dog" and explore its neighbors:
  • Find neighbors of "dog".
  • "cog" is a neighbor. Mark "cog" as visited and enqueue it.
  • Queue = "log", "cog"
  1. Dequeue "log" and explore its neighbors:
  • Find neighbors of "log".
  • No unvisited neighbors.
  • Queue = "cog"
  1. Dequeue "cog" and explore its neighbors:
  • "cog" is the endWord.
  • Return level which is 5, representing the shortest transformation sequence: "hit" -> "hot" -> "dot" -> "dog" -> "cog".
Code:
c 复制代码
bool isOneLetterDiff(char *a, char *b) {
    int diffCount = 0;
    while (*a) {
        if (*(a++) != *(b++)) diffCount++;
        if (diffCount > 1) return false;
    }
    return diffCount == 1;
}

int ladderLength(char *beginWord, char *endWord, char **wordList, int wordListSize) {
    if (!beginWord || !endWord || !wordList || wordListSize == 0) return 0;
    
    bool *visited = (bool *)calloc(wordListSize, sizeof(bool));
    char **queue = (char **)malloc(sizeof(char *) * (wordListSize + 1));
    int front = 0, rear = 0;
    
    queue[rear++] = beginWord;
    int level = 1;
    
    while (front < rear) {
        int size = rear - front;
        for (int i = 0; i < size; i++) {
            char *word = queue[front++];
            if (strcmp(word, endWord) == 0) {
                free(visited);
                free(queue);
                return level;
            }
            for (int j = 0; j < wordListSize; j++) {
                if (!visited[j] && isOneLetterDiff(word, wordList[j])) {
                    visited[j] = true;
                    queue[rear++] = wordList[j];
                }
            }
        }
        level++;
    }
    
    free(visited);
    free(queue);
    return 0;
}
相关推荐
Dream it possible!25 分钟前
LeetCode 面试经典 150_多维动态规划_交错字符串(97_C++_中等)
算法·leetcode·面试·动态规划
心抵鹊1 小时前
算法之双指针系列(一)
算法·leetcode
十二1 小时前
【洛谷题解】P1083 [NOIP 2012 提高组] 借教室(二分答案 + 差分)
数据结构·c++·算法·蓝桥杯
小此方2 小时前
[算法实战论:动态规划]回文串问题的dp解法,回文串问题的母题,以及以此为基础的派生题
算法·动态规划
Pniubi3 小时前
力扣560.和为k的子数组
算法·leetcode·职场和发展
D e re k ZH3 小时前
C++ 从零入门(一):基础语法与程序结构
数据结构·c++·算法
Pniubi4 小时前
力扣438.找到字符串中所有字母异位词
算法·leetcode·职场和发展
東隅已逝,桑榆非晚6 小时前
算法6. 双指针法-查找总价格为目标的两个商品
c++·学习·算法
Eyfcom6 小时前
〖物联网终端实战 01〗UWB 室内高精度定位:仓储 AGV 与人员的厘米级轨迹追踪
物联网·算法·物流系统·快递系统·跨境物流快递系统·物联网终端实战
bro_Java6667 小时前
《排序的底层逻辑:比较、交换与分治》
java·算法·排序算法